## vim-7.0.tar.bz2

=== runtime/doc/Makefile ===
#
# Makefile for the Vim documentation on Unix
#
# If you get "don't know how to make scratch", first run make in the source
# directory.  Or remove the include below.

AWK = awk

# Set to $(VIMTARGET) when executed from src/Makefile.
VIMEXE = vim

# include the config.mk from the source directory.  It's only needed to set
# AWK, used for "make html".  Comment this out if the include gives problems.
include ../../src/auto/config.mk

DOCS = \
	arabic.txt \
	autocmd.txt \
	change.txt \
	cmdline.txt \
	debugger.txt \
	debug.txt \
	develop.txt \
	diff.txt \
	digraph.txt \
	editing.txt \
	eval.txt \
	farsi.txt \
	filetype.txt \
	fold.txt \
	getscript.txt \
	gui.txt \
	gui_w16.txt \
	gui_w32.txt \
	gui_x11.txt \
	hangulin.txt \
	hebrew.txt \
	help.txt \
	howto.txt \
	if_cscop.txt \
	if_mzsch.txt \
	if_ole.txt \
	if_perl.txt \
	if_pyth.txt \
	if_ruby.txt \
	if_sniff.txt \
	if_tcl.txt \
	indent.txt \
	index.txt \
	insert.txt \
	intro.txt \
	map.txt \
	message.txt \
	motion.txt \
	mbyte.txt \
	mlang.txt \
	netbeans.txt \
	options.txt \
	os_390.txt \
	os_amiga.txt \
	os_beos.txt \
	os_dos.txt \
	os_mac.txt \
	os_mint.txt \
	os_msdos.txt \
	os_os2.txt \
	os_qnx.txt \
	os_risc.txt \
	os_unix.txt \
	os_vms.txt \
	os_win32.txt \
	pattern.txt \
	pi_gzip.txt \
	pi_netrw.txt \
	pi_paren.txt \
	pi_spec.txt \
	pi_tar.txt \
	pi_vimball.txt \
	pi_zip.txt \
	print.txt \
	quickfix.txt \
	quickref.txt \
	quotes.txt \
	recover.txt \
	remote.txt \
	repeat.txt \
	rileft.txt \
	russian.txt \
	scroll.txt \
	sign.txt \
	sponsor.txt \
	starting.txt \
	spell.txt \
	sql.txt \
	syntax.txt \
	tabpage.txt \
	tagsrch.txt \
	term.txt \
	tips.txt \
	todo.txt \
	uganda.txt \
	undo.txt \
	usr_01.txt \
	usr_02.txt \
	usr_03.txt \
	usr_04.txt \
	usr_05.txt \
	usr_06.txt \
	usr_07.txt \
	usr_08.txt \
	usr_09.txt \
	usr_10.txt \
	usr_11.txt \
	usr_12.txt \
	usr_20.txt \
	usr_21.txt \
	usr_22.txt \
	usr_23.txt \
	usr_24.txt \
	usr_25.txt \
	usr_26.txt \
	usr_27.txt \
	usr_28.txt \
	usr_29.txt \
	usr_30.txt \
	usr_31.txt \
	usr_32.txt \
	usr_40.txt \
	usr_41.txt \
	usr_42.txt \
	usr_43.txt \
	usr_44.txt \
	usr_45.txt \
	usr_90.txt \
	usr_toc.txt \
	various.txt \
	version4.txt \
	version5.txt \
	version6.txt \
	version7.txt \
	vi_diff.txt \
	visual.txt \
	windows.txt \
	workshop.txt

HTMLS = \
	arabic.html \
	autocmd.html \
	change.html \
	cmdline.html \
	debug.html \
	debugger.html \
	develop.html \
	diff.html \
	digraph.html \
	editing.html \
	eval.html \
	farsi.html \
	filetype.html \
	fold.html \
	getscript.html \
	gui.html \
	gui_w16.html \
	gui_w32.html \
	gui_x11.html \
	hangulin.html \
	hebrew.html \
	howto.html \
	if_cscop.html \
	if_mzsch.html \
	if_ole.html \
	if_perl.html \
	if_pyth.html \
	if_ruby.html \
	if_sniff.html \
	if_tcl.html \
	indent.html \
	index.html \
	vimindex.html \
	insert.html \
	intro.html \
	map.html \
	message.html \
	motion.html \
	mbyte.html \
	mlang.html \
	netbeans.html \
	options.html \
	os_390.html \
	os_amiga.html \
	os_beos.html \
	os_dos.html \
	os_mac.html \
	os_mint.html \
	os_msdos.html \
	os_os2.html \
	os_qnx.html \
	os_risc.html \
	os_unix.html \
	os_vms.html \
	os_win32.html \
	pattern.html \
	pi_gzip.html \
	pi_netrw.html \
	pi_paren.html \
	pi_spec.html \
	pi_tar.html \
	pi_vimball.html \
	pi_zip.html \
	print.html \
	quickfix.html \
	quickref.html \
	quotes.html \
	recover.html \
	remote.html \
	repeat.html \
	rileft.html \
	russian.html \
	scroll.html \
	sign.html \
	sponsor.html \
	starting.html \
	spell.html \
	sql.html \
	syntax.html \
	tabpage.html \
	tagsrch.html \
	tags.html \
	term.html \
	tips.html \
	todo.html \
	uganda.html \
	undo.html \
	usr_01.html \
	usr_02.html \
	usr_03.html \
	usr_04.html \
	usr_05.html \
	usr_06.html \
	usr_07.html \
	usr_08.html \
	usr_09.html \
	usr_10.html \
	usr_11.html \
	usr_12.html \
	usr_20.html \
	usr_21.html \
	usr_22.html \
	usr_23.html \
	usr_24.html \
	usr_25.html \
	usr_26.html \
	usr_27.html \
	usr_28.html \
	usr_29.html \
	usr_30.html \
	usr_31.html \
	usr_32.html \
	usr_40.html \
	usr_41.html \
	usr_42.html \
	usr_43.html \
	usr_44.html \
	usr_45.html \
	usr_90.html \
	usr_toc.html \
	various.html \
	version4.html \
	version5.html \
	version6.html \
	version7.html \
	vi_diff.html \
	visual.html \
	windows.html \
	workshop.html

CONVERTED = \
	vim-fr.UTF-8.1 \
	evim-fr.UTF-8.1 \
	vimdiff-fr.UTF-8.1 \
	vimtutor-fr.UTF-8.1 \
	xxd-fr.UTF-8.1 \
	vim-it.UTF-8.1 \
	evim-it.UTF-8.1 \
	vimdiff-it.UTF-8.1 \
	vimtutor-it.UTF-8.1 \
	xxd-it.UTF-8.1 \
	vim-ru.UTF-8.1 \
	evim-ru.UTF-8.1 \
	vimdiff-ru.UTF-8.1 \
	vimtutor-ru.UTF-8.1 \
	xxd-ru.UTF-8.1 \

.SUFFIXES:
.SUFFIXES: .c .o .txt .html

all: tags vim.man vimdiff.man vimtutor.man xxd.man $(CONVERTED)

# Use Vim to generate the tags file.  Can only be used when Vim has been
# compiled and installed.  Supports multiple languages.
vimtags: $(DOCS)
	$(VIMEXE) -u NONE -esX -c "helptags ." -c quit

# Use "doctags" to generate the tags file.  Only works for English!
tags: doctags $(DOCS)
	./doctags $(DOCS) | LANG=C LC_ALL=C sort >tags
	uniq -d -2 tags

doctags: doctags.c
	$(CC) doctags.c -o doctags

vim.man: vim.1
	nroff -man vim.1 | sed -e s/.//g > vim.man

vimdiff.man: vimdiff.1
	nroff -man vimdiff.1 | sed -e s/.//g > vimdiff.man

vimtutor.man: vimtutor.1
	nroff -man vimtutor.1 | sed -e s/.//g > vimtutor.man

xxd.man: xxd.1
	nroff -man xxd.1 | sed -e s/.//g > xxd.man

uganda.nsis.txt: uganda.txt
	sed -e 's/[ 	]*\*[-a-zA-Z0-9.]*\*//g' -e 's/vim:tw=78://' \
		uganda.txt | uniq >uganda.nsis.txt

# Awk version of .txt to .html conversion.
html: noerrors tags tags.ref $(HTMLS)
	@if test -f errors.log; then more errors.log; fi

noerrors:
	-rm -f errors.log

.txt.html:
	$(AWK) -f makehtml.awk $< >$@

# index.html is the starting point for HTML, but for the help files it is
# help.txt.  Therefore use vimindex.html for index.txt.
index.html: help.txt
	$(AWK) -f makehtml.awk help.txt >index.html

vimindex.html: index.txt
	$(AWK) -f makehtml.awk index.txt >vimindex.html

tags.ref tags.html: tags
	$(AWK) -f maketags.awk tags >tags.html

# Perl version of .txt to .html conversion.
# There can't be two rules to produce a .html from a .txt file.
# Just run over all .txt files each time one changes.  It's fast anyway.
perlhtml: tags $(DOCS)
	./vim2html.pl tags $(DOCS)

clean:
	-rm doctags *.html tags.ref

# These files are in the extra archive, skip if not present

arabic.txt:
	touch arabic.txt

farsi.txt:
	touch farsi.txt

hebrew.txt:
	touch hebrew.txt

russian.txt:
	touch russian.txt

gui_w16.txt:
	touch gui_w16.txt

gui_w32.txt:
	touch gui_w32.txt

if_ole.txt:
	touch if_ole.txt

os_390.txt:
	touch os_390.txt

os_amiga.txt:
	touch os_amiga.txt

os_beos.txt:
	touch os_beos.txt

os_dos.txt:
	touch os_dos.txt

os_mac.txt:
	touch os_mac.txt

os_mint.txt:
	touch os_mint.txt

os_msdos.txt:
	touch os_msdos.txt

os_os2.txt:
	touch os_os2.txt

os_qnx.txt:
	touch os_qnx.txt

os_risc.txt:
	touch os_risc.txt

os_win32.txt:
	touch os_win32.txt

# Note that $< works with GNU make while $> works for BSD make.
# Is there a solution that works for both??
vim-fr.UTF-8.1: vim-fr.1
	iconv -f latin1 -t utf-8 $< >$@

evim-fr.UTF-8.1: evim-fr.1
	iconv -f latin1 -t utf-8 $< >$@

vimdiff-fr.UTF-8.1: vimdiff-fr.1
	iconv -f latin1 -t utf-8 $< >$@

vimtutor-fr.UTF-8.1: vimtutor-fr.1
	iconv -f latin1 -t utf-8 $< >$@

xxd-fr.UTF-8.1: xxd-fr.1
	iconv -f latin1 -t utf-8 $< >$@

vim-it.UTF-8.1: vim-it.1
	iconv -f latin1 -t utf-8 $< >$@

evim-it.UTF-8.1: evim-it.1
	iconv -f latin1 -t utf-8 $< >$@

vimdiff-it.UTF-8.1: vimdiff-it.1
	iconv -f latin1 -t utf-8 $< >$@

vimtutor-it.UTF-8.1: vimtutor-it.1
	iconv -f latin1 -t utf-8 $< >$@

xxd-it.UTF-8.1: xxd-it.1
	iconv -f latin1 -t utf-8 $< >$@

vim-ru.UTF-8.1: vim-ru.1
	iconv -f KOI8-R -t utf-8 $< >$@

evim-ru.UTF-8.1: evim-ru.1
	iconv -f KOI8-R -t utf-8 $< >$@

vimdiff-ru.UTF-8.1: vimdiff-ru.1
	iconv -f KOI8-R -t utf-8 $< >$@

vimtutor-ru.UTF-8.1: vimtutor-ru.1
	iconv -f KOI8-R -t utf-8 $< >$@

xxd-ru.UTF-8.1: xxd-ru.1
	iconv -f KOI8-R -t utf-8 $< >$@

=== src/testdir/Makefile ===
#
# Makefile to run al tests for Vim
#

VIMPROG = ../vim

SCRIPTS = test1.out test2.out test3.out test4.out test5.out test6.out \
		test7.out test8.out test9.out test10.out test11.out \
		test12.out  test13.out test14.out test15.out test17.out \
		test18.out test19.out test20.out test21.out test22.out \
		test23.out test24.out test25.out test26.out test27.out \
		test28.out test29.out test30.out test31.out test32.out \
		test33.out test34.out test35.out test36.out test37.out \
		test38.out test39.out test40.out test41.out test42.out \
		test43.out test44.out test45.out test46.out test47.out \
		test48.out test49.out test51.out test52.out test53.out \
		test54.out test55.out test56.out test57.out test58.out \
		test59.out test60.out test61.out test62.out

SCRIPTS_GUI = test16.out

.SUFFIXES: .in .out

nongui:	nolog $(SCRIPTS)
	@echo
	@cat test.log
	@echo ALL DONE

gui:	nolog $(SCRIPTS) $(SCRIPTS_GUI)
	@echo
	@cat test.log
	@echo ALL DONE

$(SCRIPTS) $(SCRIPTS_GUI): $(VIMPROG)

clean:
	-rm -rf *.out *.failed *.rej *.orig test.log tiny.vim small.vim mbyte.vim test.ok X* viminfo

test1.out: test1.in
	-rm -f $*.failed tiny.vim small.vim mbyte.vim test.ok X* viminfo
	$(VIMPROG) -u unix.vim -U NONE --noplugin -s dotest.in $*.in
	@/bin/sh -c "if diff test.out $*.ok; \
		then mv -f test.out $*.out; \
		else echo; \
		echo test1 FAILED - Something basic is wrong; \
		echo; exit 1; fi"
	-rm -rf X* viminfo

.in.out:
	-rm -rf $*.failed test.ok test.out X* viminfo
	cp $*.ok test.ok
	# Sleep a moment to avoid that the xterm title is messed up
	@-sleep .2
	-$(VIMPROG) -u unix.vim -U NONE --noplugin -s dotest.in $*.in
	@/bin/sh -c "if test -f test.out; then\
		  if diff test.out $*.ok; \
		  then mv -f test.out $*.out; \
		  else echo $* FAILED >>test.log; mv -f test.out $*.failed; \
		  fi \
		else echo $* NO OUTPUT >>test.log; \
		fi"
	-rm -rf X* test.ok viminfo

nolog:
	-echo Test results: >test.log

=== debian/changelog ===
vim (1:7.0-219+1) unstable; urgency=low

  [ Debian Vim Maintainers ]
  * New upstream patches (165 - 219), see README.gz for details.

  [ Stefano Zacchiroli ]
  * vim-addons support:
    - converted to YAML the registry entry for matchit
  * debian/control
    - added XS-Vcs-Browser field

  [ James Vega ]
  * Fix the file test for deciding whether we need to remove alternatives to
    properly transition the Russian manpage alternatives.
  * Fix the handling of the stale diversion when /usr/bin/vim.org is already
    missing.
  * Fix the handling of alternatives which pointed at the stale alternative so
    the alternative isn't changed from auto to manual.
  * Remove the 'iskeyword' setting in Ruby's ftplugin as suggested by Tim
    Pope in #389332.
  * Add patches/netrw.vim-tmpfile_suffix_escape.diff, which escapes the suffix
    of the tmpfile filename.

 -- James Vega <jamessan@debian.org>  Tue, 20 Mar 2007 18:27:27 -0400

vim (1:7.0-164+3) unstable; urgency=low

  [ James Vega ]
  * Remove the patch notes for patches after 164 in debian/README.  Forgot
    about those when removing the patches from svn to prepare the last upload.

 -- James Vega <jamessan@debian.org>  Sun, 14 Jan 2007 10:13:00 -0500

vim (1:7.0-164+2) unstable; urgency=medium

  [ James Vega ]
  * debian/vim-variant.preinst:
    + Move diversion removal here from vim-variant.postinst.  Manually remove
      /usr/bin/vim in order to be able to remove the diversion.  Fixes
      upgrades from Sarge leaving behind stale binaries.  (closes: #401000)
    + Remove the alternatives for ru.{UTF-8,KOI8-R} manpages so the
      alternatives system doesn't attempt to keep the links around after the
      upgrade.  Fixes upgrades from Etch.  (closes: #399024)

 -- James Vega <jamessan@debian.org>  Thu,  4 Jan 2007 01:50:25 -0500

vim (1:7.0-164+1) unstable; urgency=low

  [ Debian Vim Maintainers ]
  * New upstream patches (159 - 164), see README.gz for details.

  [ James Vega ]
  * Shipped tags file was being regenerated (closes: #397837)
    - Do not pre-generate tags file, vim-runtime's postinst is already
      handling tag generation
    - Remove tags file in vim-runtime's postrm
  * Add Provides: editor to the gvim variants.  (closes: #398572)
  * Remove the empty vim-variant.postrm.
  * Move the Russian KOI8-R man pages to /usr/share/man/ru/man1 and remove the
    utf8 man pages.  man will handle the conversion.  (closes: #368754)

 -- James Vega <jamessan@debian.org>  Wed, 15 Nov 2006 08:48:51 -0500

vim (1:7.0-158+1) unstable; urgency=medium

  [ Debian Vim Maintainers ]
  * New upstream patches (153 - 158), see README.gz for details.
    - Do not let the fold level become negative. (closes: #395413)
  * Urgency medium since #396934 affects other packages.

  [ James Vega ]
  * Add vim-runtime.postinst which runs helpztags so that we don't break the
    help for other Vim addons everytime vim-runtime is upgraded.
    (closes: #396934)
  * Update the vim-basic install target in debian/rules to not rely on the
    vimcurrent symlink before it has been setup.

 -- James Vega <jamessan@debian.org>  Mon,  6 Nov 2006 22:41:59 -0500

vim (1:7.0-152+1) unstable; urgency=low

  [ Debian Vim Maintainers ]
  * New upstream patches (123 - 152), see README.gz for details.
    - Correct the button order in the GTK+ file chooser dialog so that it
      matches the GNOME Human Interface Guidelines. (closes: #367639)

  [ James Vega ]
  * Bump vim-common's priority to important to match the override.
  * Remove patch gui_gtk.c-abs_path.diff, merged upstream.
  * Remove patch gui_xmebw.c-lesstif_crash.diff, merged upstream.
  * Add patch html.vim-syntax_spell.diff, which adds support for highlighting
    of spelling mistakes. (closes: #393347)
  * Add patch changelog.vim-ftplugin_split-buffer.diff, which corrects an
    invalid command used for opening the changelog in a split window.
    (closes: #392840)

  [ Stefano Zacchiroli ]
  * Added patch dosini.vim-hash_comment.diff which adds support for # comments
    in dosini syntax highlighting, thanks to Adeodato Simó. (closes: #378952)
  * Added patch zh_TW.po-swap_recovery_typo.diff which fixes a typo in a
    traditional Chinese message when editing a file for which a swap file
    already exists. (closes: #347420)
  * debian/control
    - renamed svn info field to XS-Vcs-Svn, to match the forthcoming official
      name

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 25 Oct 2006 17:07:37 +0200

vim (1:7.0-122+1) unstable; urgency=medium

  [ Debian Vim Maintainers ]
  * New upstream patches (095 - 122), see README.gz for details.
  * Urgency medium for RC bug fixes.

  [ James Vega ]
  * Since vim-gui-common no longer depends on vim-common (to allow for
    binNMUing), make /usr/share/doc/vim-gui-common a directory instead of a
    symlink to /usr/share/doc/vim-common. (closes: #387794)
  * Add versioned Conflicts/Replaces against vim-doc for vim to allow proper
    upgrades from Sarge. (closes: #381526)
  * Update debian/copyright with the license information for the user and
    reference manuals.
  * Add patch zsh.vim-nested_quotes.diff, which fixes handling of single
    quotes nested inside double quotes. (closes: #390911)
  * Add a gnome-icon-theme Suggests for the packages which use a GTK/Gnome
    GUI.
  * Build vim-tiny with multibyte support. (closes: #361378)
  * Add patch gui_gtk.c-abs_path.diff, which ensures the GTK file selection
    dialog remembers the previously used directory. (closes: #368668)
  * Add mp.vim-cmd_check.diff, which fixes an incorrect boolean check.
    (closes: #384154)

  [ Stefano Zacchiroli ]
  * Added patches perl.vim-ftplugin_perldoc.diff,
    perl.vim-ftplugin_pydoc.diff, and ruby.vim-ftplugin_ri.diff, which trigger
    usage of perldoc/pydoc/ri for keyword lookup on perl/python/ruby files.
    (closes: #389332)

 -- James Vega <jamessan@debian.org>  Mon,  9 Oct 2006 19:37:58 -0400

vim (1:7.0-094+1) unstable; urgency=medium



=== debian/control ===
Source: vim
Section: editors
Priority: optional
Maintainer: Debian VIM Maintainers <pkg-vim-maintainers@lists.alioth.debian.org>
Uploaders: Norbert Tretkowski <nobse@debian.org>, Pierre Habouzit <madcoder@debian.org>, Matthijs Mohlmann <matthijs@cacholong.nl>, Stefano Zacchiroli <zack@debian.org>, Alexis Sukrieh <sukria@sukria.net>, Pepijn de Langen <pepijn@ce.et.tudelft.nl>, James Vega <jamessan@debian.org>
Standards-Version: 3.7.2
Build-Depends: debhelper (>= 4.2.21), dpkg (>> 1.7.0), dpkg-dev (>= 1.13.19), bzip2, perl (>= 5.6), libgpmg1-dev [!hurd-i386] | not+linux-gnu, libperl-dev (>= 5.6), tcl8.4-dev [!hurd-i386], python-dev, libxpm-dev, libncurses5-dev, ruby, ruby1.8-dev, libgtk2.0-dev (>= 2.2), libgnomeui-dev [!hurd-i386], lesstif2-dev, quilt, make (>= 3.80+3.81.b4)
Build-Conflicts: libperl-dev (= 5.8.4-1)
XS-Vcs-Svn: svn://svn.debian.org/svn/pkg-vim/trunk/packages/vim
XS-Vcs-Browser: http://svn.debian.org/wsvn/pkg-vim/trunk/packages/vim/

Package: vim-common
Priority: important
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: vim (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-full (<< 1:6.4-001+3)
Replaces: manpages-it (<= 0.3.4-3), manpages-pl (<=20060331-1), vim (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-full (<< 1:6.4-001+3), vim-runtime (<< 1:7.0-010+1)
Recommends: vim | vim-gnome | vim-gtk | vim-lesstif | vim-perl | vim-python | vim-ruby | vim-tcl | vim-full | vim-tiny
Description: Vi IMproved - Common files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains files shared by all non GUI-enabled vim
 variants (vim and vim-tiny currently) available in Debian.
 Examples of such shared files are: manpages, common executables
 like vimtutor and xxd, and configuration files.

Package: vim-gui-common
Priority: optional
Architecture: all
Conflicts: vim (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-full (<< 1:6.4-001+3)
Replaces: manpages-pl (<=20060331-1), vim (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-full (<< 1:6.4-001+3)
Recommends: vim-gnome | vim-gtk | vim-lesstif | vim-perl | vim-python | vim-ruby | vim-tcl | vim-full
Description: Vi IMproved - Common GUI files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains files shared by all GUI-enabled vim
 variants (vim-perl, vim-gnome, ...) available in Debian.
 Examples of such shared files are: icons,
 desktop environments settings, and menu entries.

Package: vim-runtime
Priority: optional
Architecture: all
Conflicts: vim-common (<< 1:6.4-007+2), vim (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-full (<< 1:6.4-001+3)
Replaces: manpages-pl (<=20060331-1), vim-common (<< 1:6.4-007+2), vim (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-full (<< 1:6.4-001+3)
Recommends: vim | vim-gnome | vim-gtk | vim-lesstif | vim-perl | vim-python | vim-ruby | vim-tcl | vim-full | vim-tiny
Enhances: vim-tiny
Description: Vi IMproved - Runtime files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains the architecture independent runtime
 files, used, if available, by all vim variants available in
 Debian. Example of such runtime files are: online documentation,
 rules for language-specific syntax highlighting and indentation,
 color schemes, and standard plugins.

Package: vim-doc
Section: doc
Priority: optional
Architecture: all
Description: Vi IMproved - HTML documentation
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains the HTML version of the online
 documentation.

Package: vim-tiny
Priority: important
Architecture: any
Depends: vim-common (= ${binary:Version}), ${shlibs:Depends}
Provides: editor
Description: Vi IMproved - enhanced vi editor - compact version
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a minimal version of vim compiled with no
 GUI and a small subset of features in order to keep small the
 package size. This package does not depend on the vim-runtime
 package, but installing it you will get its additional benefits
 (online documentation, plugins, ...).

Package: vim
Priority: optional
Architecture: any
Depends: vim-common (= ${binary:Version}), vim-runtime (= ${source:Version}), ${shlibs:Depends}
Suggests: ctags, vim-doc, vim-scripts
Provides: editor
Conflicts: vim-doc (<< 1:6.4-001+3), vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3), vim-common (<< 1:6.4-001+3)
Replaces: vim-doc (<< 1:6.4-001+3), vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3)
Description: Vi IMproved - enhanced vi editor
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contain a version of vim compiled with a rather
 standard set of features. See the other vim-* packages if you
 need more (or less).

Package: vim-perl
Priority: extra
Architecture: any
Depends: vim-gui-common (= ${source:Version}), vim-common (= ${binary:Version}), vim-runtime (= ${source:Version}), ${shlibs:Depends}
Suggests: cscope, vim-doc, ttf-bitstream-vera, gnome-icon-theme
Provides: gvim, editor
Conflicts: vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3), vim-common (<< 1:6.4-001+3)
Replaces: vim (<= 1:6.3-068+1), vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3)
Description: Vi IMproved - enhanced vi editor - with Perl support
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with Perl
 scripting support and the GTK2 GUI.

Package: vim-python
Priority: extra
Architecture: any
Depends: vim-gui-common (= ${source:Version}), vim-common (= ${binary:Version}), vim-runtime (= ${source:Version}), ${shlibs:Depends}
Suggests: cscope, vim-doc, ttf-bitstream-vera, gnome-icon-theme
Provides: gvim, editor
Conflicts: vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3), vim-common (<< 1:6.4-001+3)
Replaces: vim (<= 1:6.3-068+1), vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3)
Description: Vi IMproved - enhanced vi editor - with Python support
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with Python
 scripting support and the GTK2 GUI.

Package: vim-ruby
Priority: extra
Architecture: any
Depends: vim-gui-common (= ${source:Version}), vim-common (= ${binary:Version}), vim-runtime (= ${source:Version}), ${shlibs:Depends}
Suggests: cscope, vim-doc, ttf-bitstream-vera, gnome-icon-theme
Provides: gvim, editor
Conflicts: vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3), vim-common (<< 1:6.4-001+3)
Replaces: vim (<= 1:6.3-068+1), vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-tcl (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3)
Description: Vi IMproved - enhanced vi editor - with Ruby support
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with Ruby
 scripting support and the GTK2 GUI.

Package: vim-tcl
Priority: extra
Architecture: any
Depends: vim-gui-common (= ${source:Version}), vim-common (= ${binary:Version}), vim-runtime (= ${source:Version}), ${shlibs:Depends}
Suggests: cscope, vim-doc, ttf-bitstream-vera, gnome-icon-theme
Provides: gvim, editor
Conflicts: vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3), vim-common (<< 1:6.4-001+3)
Replaces: vim (<= 1:6.3-068+1), vim-full (<< 1:6.4-001+3), vim-gnome (<< 1:6.4-001+3), vim-gtk (<< 1:6.4-001+3), vim-lesstif (<< 1:6.4-001+3), vim-perl (<< 1:6.4-001+3), vim-python (<< 1:6.4-001+3), vim-ruby (<< 1:6.4-001+3), vim-tiny (<< 1:6.4-001+3)
Description: Vi IMproved - enhanced vi editor - with TCL support
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .

=== debian/rules ===
#!/usr/bin/make -f

export SHELL=/bin/bash
export DH_OPTIONS

DEB_HOST_GNU_SYSTEM := $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)

BUILDER := $(shell echo $${DEBEMAIL:-$${EMAIL:-$$(echo $$LOGNAME@$$(cat /etc/mailname 2> /dev/null))}})

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS+=-O0
else
  CFLAGS+=-O2
endif

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  MAKETEST = yes
else
  MAKETEST = no
endif

INSTALL+=install
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  INSTALL+=-s
endif

CFLAGS+=$(if $(findstring nodebug,$(DEB_BUILD_OPTIONS)),,-g -Wall)
CFGFLAGS+=--prefix=/usr
CFGFLAGS+=--mandir='$${prefix}'/share/man
CFGFLAGS+=--with-compiledby="$(BUILDER)"

# "vim-tiny" features: in addition to those coming from the --with-features=xxx,
# "vim-tiny" is built with those listed in debian/tiny/features.txt
TINYFLAGS+=--with-features=small
TINYFLAGS+=--disable-syntax
TINYFLAGS+=--disable-gui
TINYFLAGS+=--disable-xsmp
TINYFLAGS+=--disable-xsmp-interact
TINYFLAGS+=--disable-netbeans
TINYFLAGS+=--disable-acl
TINYFLAGS+=--disable-gpm
TINYFLAGS+=--enable-nls
TINYFLAGS+=--enable-multibyte
TINYFLAGS+=--enable-multilang

# add -DFEAT_* from debian/tiny/features.txt
TINYCFLAGS:=$(patsubst %,-D%,$(shell grep ^FEAT_ debian/tiny/features.txt | cut -f 1))

OPTFLAGS+=--enable-gpm
OPTFLAGS+=--enable-cscope
OPTFLAGS+=--with-features=big
OPTFLAGS+=--enable-multibyte

GUIFLAGS+=--with-x
GUIFLAGS+=--enable-xim
GUIFLAGS+=--enable-fontset
GTK2FLAGS+=--enable-gui=gtk2
GTK2FLAGS+=--with-features=big

GNOMEFLAGS+=--enable-gui=gnome2

LESSTIFFLAGS+=--enable-gui=motif

PERLFLAGS+=--enable-perlinterp
PERLFLAGS+=--disable-mzschemeinterp
PERLFLAGS+=--disable-pythoninterp
PERLFLAGS+=--disable-rubyinterp
PERLFLAGS+=--disable-tclinterp

PYTHONFLAGS+=--enable-pythoninterp
PYTHONFLAGS+=--disable-mzschemeinterp
PYTHONFLAGS+=--disable-perlinterp
PYTHONFLAGS+=--disable-rubyinterp
PYTHONFLAGS+=--disable-tclinterp

RUBYFLAGS+=--enable-rubyinterp
RUBYFLAGS+=--disable-mzschemeinterp
RUBYFLAGS+=--disable-perlinterp
RUBYFLAGS+=--disable-pythoninterp
RUBYFLAGS+=--disable-tclinterp

TCLFLAGS+=--enable-tclinterp
TCLFLAGS+=--disable-mzschemeinterp
TCLFLAGS+=--disable-perlinterp
TCLFLAGS+=--disable-pythoninterp
TCLFLAGS+=--disable-rubyinterp

BASICFLAGS+=--disable-mzschemeinterp
BASICFLAGS+=--disable-tclinterp
BASICFLAGS+=--disable-perlinterp
BASICFLAGS+=--disable-pythoninterp
BASICFLAGS+=--disable-rubyinterp

ALLINTERPFLAGS+=--disable-mzschemeinterp
ALLINTERPFLAGS+=--enable-perlinterp
ALLINTERPFLAGS+=--enable-pythoninterp
ALLINTERPFLAGS+=--enable-rubyinterp
ALLINTERPFLAGS+=--enable-tclinterp

# Each vim-xxx package is said to be a vim variant and contains only a vim
# binary built with some compile-time options. Makefile VARIANTS below are
# one-to-one with those packages with the exception of "vim-basic". In this
# Makefile vim-basic is used to built 4 packages: "vim", "vim-runtime",
# "vim-common", "vim-gui-common". "vim-tiny" is the only variant package not
# depending on vim-runtime.

# vim-basic must be the last one
ifneq ($(DEB_HOST_GNU_SYSTEM),gnu)
	VARIANTS+=vim-tiny
	VARIANTS+=vim-ruby
	VARIANTS+=vim-tcl
	VARIANTS+=vim-gtk
	VARIANTS+=vim-lesstif
	VARIANTS+=vim-perl
	VARIANTS+=vim-python
	VARIANTS+=vim-gnome
	VARIANTS+=vim-full
	VARIANTS+=vim-basic
else
	VARIANTS+=vim-tiny
	VARIANTS+=vim-ruby
	VARIANTS+=vim-gtk
	VARIANTS+=vim-python
	VARIANTS+=vim-lesstif
	VARIANTS_SKIP+=vim-perl
	VARIANTS_SKIP+=vim-gnome
	VARIANTS_SKIP+=vim-tcl
	VARIANTS_SKIP+=vim-full
	VARIANTS+=vim-basic
endif
ifeq ($(origin VARIANT), command line)
	VARIANTS = $(VARIANT) vim-basic
endif

CFLAGS_vim-basic=$(CFLAGS)
CFGFLAGS_vim-basic=$(CFGFLAGS) $(OPTFLAGS) --without-x --enable-gui=no

CFLAGS_vim-tiny=$(CFLAGS) $(TINYCFLAGS)
CFGFLAGS_vim-tiny=$(CFGFLAGS) $(TINYFLAGS)

CFLAGS_vim-perl=$(CFLAGS)
CFGFLAGS_vim-perl=$(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(PERLFLAGS) $(GTK2FLAGS)

CFLAGS_vim-python=$(CFLAGS)
CFGFLAGS_vim-python=$(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(PYTHONFLAGS) $(GTK2FLAGS)

CFLAGS_vim-ruby=$(CFLAGS)
CFGFLAGS_vim-ruby=$(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(RUBYFLAGS) $(GTK2FLAGS)

CFLAGS_vim-tcl=$(CFLAGS)
CFGFLAGS_vim-tcl=$(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(TCLFLAGS) $(GTK2FLAGS)

CFLAGS_vim-gtk=$(CFLAGS)
CFGFLAGS_vim-gtk=$(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(BASICFLAGS) $(GTK2FLAGS)

CFLAGS_vim-gnome=$(CFLAGS)
CFGFLAGS_vim-gnome=$(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(BASICFLAGS) $(GNOMEFLAGS)

CFLAGS_vim-lesstif=$(CFLAGS)
CFGFLAGS_vim-lesstif=$(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(BASICFLAGS) $(LESSTIFFLAGS)

CFLAGS_vim-full=$(CFLAGS)
CFGFLAGS_vim-full=$(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(GNOMEFLAGS) $(ALLINTERPFLAGS)

NAME=vim
VERSION=7.0
DEBVERSION=$(VERSION)
VIMCUR=$(NAME)$(subst .,,$(VERSION))
SRCDIR=$(VIMCUR)
CHANGELOG=$(SRCDIR)/runtime/doc/version7.txt # latest version upstream changelog
MAIN_TARBALL=$(NAME)-$(VERSION).tar.bz2
LANG_TARBALL=$(NAME)-$(VERSION)-lang.tar.gz
EXTRA_TARBALL=$(NAME)-$(VERSION)-extra.tar.gz
SOURCES = $(MAIN_TARBALL) $(LANG_TARBALL) $(EXTRA_TARBALL)
PER_VARIANT_FILES = install postinst prerm links preinst
LANGS += fr fr.ISO8859-1 fr.UTF-8
LANGS += it it.ISO8859-1 it.UTF-8
LANGS += pl pl.ISO8859-2 pl.UTF-8
LANGS += ru

DOT_IN_DEPS = debian/vim-runtime.install
DOT_IN_DEPS += debian/vim-runtime.install
DOT_IN_DEPS += debian/vim-common.install
DOT_IN_DEPS += debian/vim-gui-common.install
DOT_IN_DEPS += debian/vim-common.links
DOT_IN_DEPS += debian/vim-gui-common.links
DOT_IN_DEPS += debian/vim-runtime.links
DOT_IN_DEPS += debian/runtime/debian.vim

# nothing to do per default
all:

extract: extract-stamp
extract-stamp: $(foreach s,$(SOURCES),extract-stamp-$(s))
	if [ ! -L vim -o "`readlink vim`" != "$(VIMCUR)" ]; then \
	  ln -fs $(SRCDIR) vim; \
	fi
	@for f in `find upstream/patches -type f -name '$(VERSION).*' -printf "%P\n" | grep -v .svn | sort -n` ; do\
	  echo "applying upstream patch: $$f" ;\
	  cat upstream/patches/$$f | patch -s -d$(SRCDIR) -p0 ;\
	done
	quilt push -a
	touch $@

# {{{1 hackish way of updating to latest unstable snapshot
# XXX Zack: should this be removed and/or ported to svn-buildpackage?
updatesnapshot:
	zipurl=`uscan --report | tail -2 | head -1` \
	&& test ! -z "$$zipurl" \
	&& zipbasename=`basename $$zipurl` \
	&& wget -O upstream/tarballs/$$zipbasename $$zipurl \
	&& noext=`echo $$zipbasename | sed 's/.zip//'` \
	&& rulesversion=`echo $$noext | cut -c5-8` \
	&& rulessnapshot=`echo $$noext | cut -c9-10` \
	&& sedcmd="s/^VERSION=.*/VERSION=$$rulesversion/;s/^SNAPSHOT=.*/SNAPSHOT=$$rulessnapshot/" \
	&& sed -i.bak "$$sedcmd" debian/rules \
	&& sed -i.bak "1{s/+.*-/+$$rulesversion$$rulessnapshot-/};4{s/(......)/($$rulesversion$$rulessnapshot)/}" debian/changelog
# }}}

extract-stamp-%.bz2:
	bunzip2 -c upstream/tarballs/$(*).bz2 | tar -x
	touch $@

extract-stamp-%.gz:
	gunzip -c upstream/tarballs/$(*).gz | tar -x
	touch $@

extract-stamp-%.zip:
	unzip -d $(SRCDIR) upstream/tarballs/$(*).zip
	touch $@

clean: $(foreach v,$(VARIANTS),clean-$(v))
	dh_testdir
	dh_testroot
	rm -f extract-stamp* build-stamp* install-stamp*
	rm -f debian/helpztags.1
	- quilt pop -a
	rm -rf $(SRCDIR)
	rm -f vim
	dh_clean

clean-vim-basic:
	for x in $(PER_VARIANT_FILES) ; do \
	  rm -f debian/vim.$$x ; \
	done
	for x in vim-gui-common.{install,links} vim-common.{install,links} \
	         vim-runtime.install; do \
	  rm -f debian/$$x; \
	done
	rm -f $(DOT_IN_DEPS)

clean-%:
	for x in $(PER_VARIANT_FILES) ; do \
	  rm -f debian/$*.$$x ; \
	done
	rm -f debian/vim.links
	rm -f debian/lintian/$*

build: extract
build: build-stamp
build-stamp: $(foreach v,$(VARIANTS),build-stamp-$(v))
	$(MAKE) -C $(SRCDIR)/runtime/doc html # gen html docs (destroys tags)
# (re)generate the tags file
#	$(SRCDIR)/src/vim-common -u /dev/null \
#	  -c "helptags $(SRCDIR)/runtime/doc" -c quit
	touch $@

configure-stamp-%:
	dh_testdir
	@echo "*** DEBIAN *** CONFIGURING VARIANT $*"
	$(MAKE) -C $(SRCDIR) clean
	cd $(SRCDIR) \
	  && make distclean \
